diff --git a/isisd/isis_tlvs.c b/isisd/isis_tlvs.c
index 35d1aef6f105..312810cde354 100644
--- a/isisd/isis_tlvs.c
+++ b/isisd/isis_tlvs.c
@@ -6759,6 +6759,18 @@ void isis_tlvs_set_purge_originator(struct isis_tlvs *tlvs,
 	}
 }
 
+/* Set SRv6 SID Structure Sub-Sub-TLV parameters */
+void isis_subsubtlvs_set_srv6_sid_structure(struct isis_subsubtlvs *subsubtlvs,
+					    struct isis_srv6_sid *sid)
+{
+	assert(!subsubtlvs->srv6_sid_structure);
+
+	subsubtlvs->srv6_sid_structure = XCALLOC(
+		MTYPE_ISIS_SUBSUBTLV, sizeof(*subsubtlvs->srv6_sid_structure));
+
+	isis_srv6_sid_structure2subsubtlv(sid, subsubtlvs->srv6_sid_structure);
+}
+
 /* Add an SRv6 End SID to the SRv6 End SID Sub-TLV */
 void isis_subtlvs_add_srv6_end_sid(struct isis_subtlvs *subtlvs,
 				   struct isis_srv6_sid *sid)
diff --git a/isisd/isis_tlvs.h b/isisd/isis_tlvs.h
index 8960ad034739..c157061a6c7a 100644
--- a/isisd/isis_tlvs.h
+++ b/isisd/isis_tlvs.h
@@ -720,6 +720,8 @@ void isis_tlvs_set_purge_originator(struct isis_tlvs *tlvs,
 				    const uint8_t *generator,
 				    const uint8_t *sender);
 
+void isis_subsubtlvs_set_srv6_sid_structure(struct isis_subsubtlvs *subsubtlvs,
+					    struct isis_srv6_sid *sid);
 void isis_subtlvs_add_srv6_end_sid(struct isis_subtlvs *subtlvs,
 				   struct isis_srv6_sid *sid);
 void isis_tlvs_add_srv6_locator(struct isis_tlvs *tlvs,
